unit WinForm1;

// Delphi.Net Sample 2oo3 by StJo (stjo@borland.com)
// delphi.win32 by max@kleiner.com  :2005  loc:299

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
 	TMyLabel = class(TLabel)
    procedure Label1Click(Sender: TObject);
  private
  	lblx,lbly,okx,oky: integer;
		place: Boolean;
	end;

  TwinForm = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    maxx,
    maxy,
    maxtot: Byte;
   	psize,
		freex,
    freey: integer;
    procedure moveCube(o: TMyLabel);
    procedure verify;
    procedure Melt2Test;
    procedure Melt;
    procedure SpeakV(const sText: string; bWithVoice: Boolean = True);
    procedure TVCLForm_Load;
  protected
		mylabels: TList;
    pattern: string;
    ttest, patternmode: shortstring;
    procedure Init;
    procedure defFileread;
  end;


  var winForm: TwinForm;

implementation

// to hear the voice
uses comObj;

{$R *.dfm}

procedure TWinForm.TVCLForm_Load;
begin
  Self.Text := 'PuzzleMax';
  //range of puzzle stones, ex. 4*5
  maxx:= 3;
  maxy:= 3;
  psize:= 64;
  defFileRead;
  maxtot:= maxx * maxy;
  maxtot:= maxtot -1;
  init();
end;

procedure TWinForm.Init;
var
  i,x,y: integer;
  mylabel1: TMyLabel;
begin
  mylabels:= TList.Create;
  Self.width:= (maxx*psize)+ 12;
  self.Height:= (maxy*psize)+ 34;
	x:= 1;
  y:= 1;
  for i:=1 to maxtot do begin
    mylabel1:= TMyLabel.Create(self);
    with mylabel1 do begin
      Parent:= winForm;
      Color:= clcream;
      AutoSize:= false;
      layout:= tlcenter;
      alignment:= tacenter;
      font.Size:= maxx + maxy;
      font.Style:= [fsbold];
      font.Color:= clpurple;
      Width:= psize;
      Height:= psize;
      lblx:= x;
      okx:= x;
      lbly:= y;
      oky:= y;
    end;
    if (i mod maxx=0) then begin
      x:=1; inc(y);
    end else inc(x);
    if uppercase(patternmode) = uppercase('YES') then begin
      if length(pattern) = maxtot then
        mylabel1.caption:= pattern[i] else begin
          showmessage('pattern word must have the size of the puzzle: '
                            + inttoStr(maxtot));
          exit;
        end
      end else
        mylabel1.caption:= IntToStr(i);
    //Include(mylabel1.MouseDown, Self.LabelMouseDown);
    mylabel1.OnClick:= mylabel1.Label1Click;
    mylabels.Add(mylabel1);
  end;
  //melt2test is to test verify
  if uppercase(ttest) = uppercase('YES') then
    melt2Test else
    melt;
end;


procedure TWinForm.moveCube(o: TMyLabel);
begin
  if (o.lblx + 1 = freex) and (o.lbly = freey) then begin
    // right
    o.lblx:= o.lblx +1;
    o.Left:= o.Left + psize +1;
    o.Top:= o.Top;
    freex:= freex -1;
  end else
  if (o.lblx - 1 = freex) and (o.lbly = freey) then begin
      // left
      o.lblx:= o.lblx -1;
      o.Left:= o.Left - psize -1;
      o.Top:= o.Top;
      freex:= freex +1;
  end else
  if (o.lblx = freex) and (o.lbly - 1 = freey) then begin
      // top means up
      o.lbly:= o.lbly -1;
      o.Left:= o.Left;
      o.Top:= o.Top - psize -1;
      freey:= freey + 1;
  end else
  if (o.lblx = freex) and (o.lbly + 1 = freey) then begin
      // bottom means down
      o.lbly:= o.lbly +1;
      o.Left:= o.Left;
      o.Top:= o.Top + psize +1;
      freey := freey - 1;
   end;
 end;


procedure TWinForm.Melt;
var
  i,nbplace,x,y: integer;
begin
  nbplace:= 0;
  x:= 1;
  y:= 1;
  for i:=1 to maxtot do begin
    TMyLabel(mylabels[i-1]).place:= false;
    TMyLabel(mylabels[i-1]).Visible:= false;
  end;
  RANDOMIZE;
  while (nbplace < maxtot) do begin
    i:= random(maxtot);
    if not(TMyLabel(mylabels[i]).place) then begin
      inc(nbplace);
      TMyLabel(mylabels[i]).place:= true;
      TMyLabel(mylabels[i]).Visible:= true;
      TMyLabel(mylabels[i]).lblx:= x;
      TMyLabel(mylabels[i]).lbly:= y;
      TMyLabel(mylabels[i]).Left:= (x-1)*(psize + 1);
      TMyLabel(mylabels[i]).Top:= (y-1)*(psize + 1);
      inc(x);
      if (x mod maxx=1) then begin
        x:= 1;
        inc(y);
      end;
    end;
  end;
  freex:= maxx;
  freey:= maxy;
end;

procedure TWinForm.Melt2Test;
var
  i,nbplace,x,y:integer;
begin
  nbplace:=0;
  x:=1;
  y:=1;
  for i:= 1 to maxtot do begin
    TMyLabel(mylabels[i-1]).place:= false;
    TMyLabel(mylabels[i-1]).Visible:= false;
  end;
  i:= 0;
  while (nbplace < maxtot) do begin
    if not(TMyLabel(mylabels[i]).place) then begin
      inc(nbplace);
      TMyLabel(mylabels[i]).place:= true;
      TMyLabel(mylabels[i]).Visible:= true;
      TMyLabel(mylabels[i]).Left:= (x-1)*(psize + 1);
      TMyLabel(mylabels[i]).Top:= (y-1)*(psize + 1);
      inc(x);
      inc(i);
      if (x mod maxx=1) then begin
        x:=1;
        inc(y);
      end;
    end;
  end;
  freex:= maxx;
  freey:= maxy;
end;


procedure TWinForm.Verify;
var
  i,nbok: integer;
  o: TMyLabel;
begin
  nbok:= 0;
  for i:= 1 to maxtot do begin
    o:= TMyLabel(mylabels[i-1]);
    if ((o.lblx=o.okx) and (o.lbly=o.oky)) then
      inc(nbok);
  end;
  if (nbok=maxtot) then begin
    //showmessage('Congralutations'#13#10'You win with Max Delphi.Win32 !');
    SpeakV('Congratulations You win with Maxland Delphi.Win32');
  end;
end;

procedure TwinForm.FormCreate(Sender: TObject);
begin
  TVCLForm_Load;
end;

{ TMyLabel }
// or to call winform eventhandler
procedure TMyLabel.Label1Click(Sender: TObject);
//var
  //o: TMyLabel;
begin
  if (Sender is TMyLabel) then begin
    //o:= TMyLabel(Sender);
    winForm.moveCube(TMyLabel(Sender));
    winForm.verify;
  end;
end;

// ex. of read some text with a voice
procedure TwinForm.SpeakV(const sText: String; bWithVoice: Boolean);
const
  SVSFDefault = $00000000;
  SVSFlagsAsync = $00000001;
var
  oVoice: OLEVariant;
begin
   if bWithVoice then begin
     oVoice:= CreateOLEObject('SAPI.SpVoice');
     oVoice.Speak(sText, SVSFlagsAsync);
   end;
   Showmessage(sText);
     //oVoice:= NIL;
     //oVoice:= Unassigned;
end;

procedure TwinForm.defFileread;
var deflist: TStringlist;
     filepath, fN: string;
begin
deflist:= TStringlist.create;
filepath:= ExtractFilePath(Application.ExeName);
  try
    fN:= filepath+ 'puzzledef.ini';
    if fileexists(fN) then begin
      deflist.LoadFromFile(fN);
      maxx:= strtoInt(deflist.Values['SIZE_X']);
      maxy:= strtoInt(deflist.values['SIZE_Y']);
      psize:= strToInt(deflist.values['PSIZE']);
      ttest:= deflist.values['TEST'];
      patternmode:= deflist.values['PATTERNMODE'];
      pattern:= deflist.values['PATTERN'];
    end else begin
      deflist.add('//Definitions for puzzle game');
      deflist.values['SIZE_X']:= '3';
      deflist.values['SIZE_Y']:= '3';
      deflist.values['PSIZE']:= '64';
      deflist.values['TEST']:= 'NO';
      deflist.values['PATTERNMODE']:= 'NO';
      deflist.values['PATTERN']:= 'MAXLANDS';
      deflist.SaveToFile(fN);
    end;
  finally
    deflist.Free
 end;
end;

end.
